<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFeatureResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfFeatureResult extends AbstractStructArrayBase
{
    /**
     * The FeatureResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FeatureResult[]
     */
    public $FeatureResult;
    /**
     * Constructor method for ArrayOfFeatureResult
     * @uses ArrayOfFeatureResult::setFeatureResult()
     * @param \StructType\FeatureResult[] $featureResult
     */
    public function __construct(array $featureResult = array())
    {
        $this
            ->setFeatureResult($featureResult);
    }
    /**
     * Get FeatureResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FeatureResult[]|null
     */
    public function getFeatureResult()
    {
        return isset($this->FeatureResult) ? $this->FeatureResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFeatureResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFeatureResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFeatureResultForArrayConstraintsFromSetFeatureResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFeatureResultFeatureResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfFeatureResultFeatureResultItem instanceof \StructType\FeatureResult) {
                $invalidValues[] = is_object($arrayOfFeatureResultFeatureResultItem) ? get_class($arrayOfFeatureResultFeatureResultItem) : sprintf('%s(%s)', gettype($arrayOfFeatureResultFeatureResultItem), var_export($arrayOfFeatureResultFeatureResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FeatureResult property can only contain items of type \StructType\FeatureResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FeatureResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FeatureResult[] $featureResult
     * @return \ArrayType\ArrayOfFeatureResult
     */
    public function setFeatureResult(array $featureResult = array())
    {
        // validation for constraint: array
        if ('' !== ($featureResultArrayErrorMessage = self::validateFeatureResultForArrayConstraintsFromSetFeatureResult($featureResult))) {
            throw new \InvalidArgumentException($featureResultArrayErrorMessage, __LINE__);
        }
        if (is_null($featureResult) || (is_array($featureResult) && empty($featureResult))) {
            unset($this->FeatureResult);
        } else {
            $this->FeatureResult = $featureResult;
        }
        return $this;
    }
    /**
     * Add item to FeatureResult value
     * @throws \InvalidArgumentException
     * @param \StructType\FeatureResult $item
     * @return \ArrayType\ArrayOfFeatureResult
     */
    public function addToFeatureResult(\StructType\FeatureResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FeatureResult) {
            throw new \InvalidArgumentException(sprintf('The FeatureResult property can only contain items of type \StructType\FeatureResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FeatureResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FeatureResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FeatureResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FeatureResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FeatureResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FeatureResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FeatureResult
     */
    public function getAttributeName()
    {
        return 'FeatureResult';
    }
}
